#!/bin/sh

echo "WARNING: DO NOT PROCEED UNLESS YOU KNOW YOU ARE LOSING DATA!"

echo -n "Dump current DB [yN]?"
read YORN
if [ $YORN != 'y' -a $YORN != 'Y' ]; then
	exit
fi
echo "OK..."
mysqladmin -u root -p drop LCA2003-Reg

echo -n "Create DB [yN]?"
read YORN
if [ $YORN != 'y' -a $YORN != 'Y' ]; then
	exit
fi
echo "OK..."
mysqladmin -u root -p create LCA2003-Reg 
echo -n "Reload DB [yN]?"
read YORN
if [ $YORN != 'y' -a $YORN != 'Y' ]; then
	exit;
fi
echo "OK..."
mysqladmin -u root -p reload

echo -n "Create tables and load data [yN]?";
read YORN
if [ $YORN != 'y' -a $YORN != 'Y' ]; then
	exit;
fi

mysql -u root -p LCA2003-Reg <<__EOF__
# The Person table has each individuals preferences

CREATE TABLE Person (ID integer primary key auto_increment, 
Name varchar(200) not null, 
Class varchar(50),
Email_Address varchar(150) not null, 
KEY index_Email_Address (Email_Address(10)),
Company_Name varchar(255),
Telephone varchar(100), 
Vegitarian tinyint, 
Shirt_Size varchar(4), 
Registration_Type_ID tinyint not null, 
Formal_Dinner tinyint, 
Preferred_Shell_ID tinyint, 
Preferred_Distribution_ID tinyint, 
Preferred_Editor_ID tinyint, 
Date_Entered datetime not null, 
Address varchar(200), 
PostCode varchar(20), 
State varchar(50), 
Country varchar(50), 
Experience tinyint, 
Host varchar(100) not null, 
Special_Requirements varchar(255), 
Accomodation_Start date, 
Accomodation_End date, 
lca2002 tinyint,
lca2001 tinyint,
lca1999 tinyint,
CustNum varchar(255) not null,
KEY index_CustNum (CustNum(10)));



# This is the types of registrations we have

CREATE TABLE Registration_Type (ID smallint primary key auto_increment, 
Name varchar(100), 
Cost float(4,2));




# If we have discounts, we let them be used by having secret trigger words 
# in our 'special requirements' field.

CREATE TABLE Discounts (ID smallint primary key auto_increment, 
Name varchar(100) unique, 
Access_Code varchar(100), 
Discount_Percent tinyint, 
Count tinyint);

# And the use of these discounts....

CREATE TABLE Discounts_Used(ID int primary key auto_increment,
Discount_ID smallint,
CustNum varchar(255),
Date datetime,
IP varchar(255));

# A couple of other normalised preferences

CREATE TABLE Preferred_Shells (ID tinyint primary key auto_increment, 
Name varchar(100));


CREATE TABLE Preferred_Distributions (ID tinyint primary key auto_increment, 
Name varchar(100));


CREATE TABLE Preferred_Editors (ID tinyint primary key auto_increment, 
Name varchar(100));


CREATE TABLE Time_Periods (ID tinyint primary key auto_increment, 
Name varchar(100), 
At datetime);


# We have some extra charges - dinner, etc
CREATE TABLE Extra_Charges (ID tinyint primary key auto_increment, 
Name varchar(100), 
Cost float(4,2));


# For single submit forms.
CREATE TABLE Form_Cookie (ID int primary key auto_increment, 
Cookie varchar(200) not null, 
Tag varchar(255) not null, 
Expiry DateTime not null);


# Some variables we have
CREATE TABLE Variable (ID int primary key auto_increment, 
Name varchar(200) not null, 
KEY index_Name (name(10)),
Value text not null);

CREATE TABLE Misc_Payments(ID int primary key auto_increment,
Date timestamp not null,
Host varchar(255) not null,
CustNum varchar(255) not null,
index index_CustNum (CustNum(5)),
Amount float (6,2) not null,
Customer_Comments text,
Private_Comments text,
Operator varchar(255)
);

# CommSecure.

CREATE TABLE CommSecure_Payments(ID int primary key auto_increment,
Date datetime not null, 
Host varchar(255) not null,
RefNum varchar(30),
index index_refnum(RefNum(7)),
Amount int not null,
Response varchar(5) not null,
AuthNo varchar(255),
Audit varchar(255),
ErrorMsg varchar(255),
Sig text not null);

CREATE TABLE CommSecure_Request(ID int primary key auto_increment,
Date datetime not null,
Host varchar(255) not null,
MerchantNum varchar(255) not null,
RefNum varchar(255) not null,
index index_refnum(RefNum(7)),
Amount int not null,
CustNum varchar(255) not null,
index index_CustNum(CustNum(7)),
MemberNum varchar(255),
MerchantData blob,
Description text);

CREATE TABLE CommSecure_Validate(ID int primary key auto_increment,
Date datetime not null,
Host varchar(255) not null,
RefNum varchar(255) not null,
index index_RefNum(RefNum(7)),
Amount int);


CREATE TABLE Receipt (ID int primary key auto_increment,
Date timestamp not null,
CustNum varchar(255) not null,
index index_CustNum(CustNum(7)),
RefNum varchar(255) not null,
index index_RefNum(Refnum(5)),
Text text not null, 
Amount float(4,2),
Type varchar(1));

# Data

INSERT INTO Preferred_Distributions (Name) VALUES ("Caldera");
INSERT INTO Preferred_Distributions (Name) VALUES ("Debian GNU/Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Mandrake");
INSERT INTO Preferred_Distributions (Name) VALUES ("Red Hat");
INSERT INTO Preferred_Distributions (Name) VALUES ("Slackware");
INSERT INTO Preferred_Distributions (Name) VALUES ("Suse");
INSERT INTO Preferred_Distributions (Name) VALUES ("TurboLinux");


INSERT INTO Preferred_Distributions (Name) VALUES ("ASPLinux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Beehive");
INSERT INTO Preferred_Distributions (Name) VALUES ("Conectiva");
INSERT INTO Preferred_Distributions (Name) VALUES ("E-Smith");
INSERT INTO Preferred_Distributions (Name) VALUES ("Kondara MNU/Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Rock");
INSERT INTO Preferred_Distributions (Name) VALUES ("SOT");

INSERT INTO Preferred_Distributions (Name) VALUES ("Desktop/LX");
INSERT INTO Preferred_Distributions (Name) VALUES ("ELX, Everyones Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Evil Entity");
INSERT INTO Preferred_Distributions (Name) VALUES ("Icepack");
INSERT INTO Preferred_Distributions (Name) VALUES ("Independence");
INSERT INTO Preferred_Distributions (Name) VALUES ("LibraNet");
INSERT INTO Preferred_Distributions (Name) VALUES ("MIZI");
INSERT INTO Preferred_Distributions (Name) VALUES ("OEone HomeBase");
INSERT INTO Preferred_Distributions (Name) VALUES ("WinLinux");
INSERT INTO Preferred_Distributions (Name) VALUES ("WinSlack");
INSERT INTO Preferred_Distributions (Name) VALUES ("ALT Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Arch Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Bear Ops");
INSERT INTO Preferred_Distributions (Name) VALUES ("Gentoo");
INSERT INTO Preferred_Distributions (Name) VALUES ("Bad Penguin");
INSERT INTO Preferred_Distributions (Name) VALUES ("PingOO");
INSERT INTO Preferred_Distributions (Name) VALUES ("Happy");
INSERT INTO Preferred_Distributions (Name) VALUES ("Miricale");
INSERT INTO Preferred_Distributions (Name) VALUES ("Vine");
INSERT INTO Preferred_Distributions (Name) VALUES ("WOWLinux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Embedded Debian");
INSERT INTO Preferred_Distributions (Name) VALUES ("FlightLinux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Hard Hat");
INSERT INTO Preferred_Distributions (Name) VALUES ("LEAF");
INSERT INTO Preferred_Distributions (Name) VALUES ("Linux From Scratch (LFS)");
INSERT INTO Preferred_Distributions (Name) VALUES ("Midori");
INSERT INTO Preferred_Distributions (Name) VALUES ("United Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Sun Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("RTLinux");
INSERT INTO Preferred_Distributions (Name) VALUES ("uClinux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Agenda-VR");
INSERT INTO Preferred_Distributions (Name) VALUES ("OpenZaurus");
INSERT INTO Preferred_Distributions (Name) VALUES ("PocketLinux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Castle");
INSERT INTO Preferred_Distributions (Name) VALUES ("Engarde Secure Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("NSA Security Enhanced Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Smoothwall");
INSERT INTO Preferred_Distributions (Name) VALUES ("Trustix");
INSERT INTO Preferred_Distributions (Name) VALUES ("ChainSaw");
INSERT INTO Preferred_Distributions (Name) VALUES ("Scyld Beowult");
INSERT INTO Preferred_Distributions (Name) VALUES ("xbox-linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Coyote");
INSERT INTO Preferred_Distributions (Name) VALUES ("Freesco");
INSERT INTO Preferred_Distributions (Name) VALUES ("Linux Router Project");
INSERT INTO Preferred_Distributions (Name) VALUES ("Tomsrtbt");
INSERT INTO Preferred_Distributions (Name) VALUES ("Knoppix");
INSERT INTO Preferred_Distributions (Name) VALUES ("User Mode Linux");
INSERT INTO Preferred_Distributions (Name) VALUES ("Flying Linux");

INSERT INTO Preferred_Distributions (Name) VALUES ("Red Flag");
INSERT INTO Preferred_Distributions (Name) VALUES ("Best");

INSERT INTO Preferred_Distributions (Name) VALUES ("Intimate");
INSERT INTO Preferred_Distributions (Name) VALUES ("Familiar");

INSERT INTO Preferred_Distributions (Name) VALUES ("FreeBSD");
INSERT INTO Preferred_Distributions (Name) VALUES ("NetBSD");
INSERT INTO Preferred_Distributions (Name) VALUES ("OpenBSD");

INSERT INTO Preferred_Distributions (Name) VALUES ("I rolled my own");
INSERT INTO Preferred_Distributions (Name) VALUES ("I don't use a distribution");
INSERT INTO Preferred_Distributions (Name) VALUES ("* Other *");

INSERT INTO Preferred_Shells (Name) VALUES ("bash");
INSERT INTO Preferred_Shells (Name) VALUES ("sh");
INSERT INTO Preferred_Shells (Name) VALUES ("csh");
INSERT INTO Preferred_Shells (Name) VALUES ("tcsh");
INSERT INTO Preferred_Shells (Name) VALUES ("ksh");
INSERT INTO Preferred_Shells (Name) VALUES ("esh");
INSERT INTO Preferred_Shells (Name) VALUES ("lsh");
INSERT INTO Preferred_Shells (Name) VALUES ("zsh");
INSERT INTO Preferred_Shells (Name) VALUES ("rc");
INSERT INTO Preferred_Shells (Name) VALUES ("smrsh");
INSERT INTO Preferred_Shells (Name) VALUES ("sash");
INSERT INTO Preferred_Shells (Name) VALUES ("* Other *");

INSERT INTO Preferred_Editors (Name) VALUES ("vi");
INSERT INTO Preferred_Editors (Name) VALUES ("nvi");
INSERT INTO Preferred_Editors (Name) VALUES ("vim");
INSERT INTO Preferred_Editors (Name) VALUES ("vigor");
INSERT INTO Preferred_Editors (Name) VALUES ("joe");
INSERT INTO Preferred_Editors (Name) VALUES ("aee");
INSERT INTO Preferred_Editors (Name) VALUES ("emacs");
INSERT INTO Preferred_Editors (Name) VALUES ("elvis");
INSERT INTO Preferred_Editors (Name) VALUES ("jed");
INSERT INTO Preferred_Editors (Name) VALUES ("kate");
INSERT INTO Preferred_Editors (Name) VALUES ("nano");
INSERT INTO Preferred_Editors (Name) VALUES ("sex");
INSERT INTO Preferred_Editors (Name) VALUES ("sted");
INSERT INTO Preferred_Editors (Name) VALUES ("ted");
INSERT INTO Preferred_Editors (Name) VALUES ("xcoral");
INSERT INTO Preferred_Editors (Name) VALUES ("xed");
INSERT INTO Preferred_Editors (Name) VALUES ("jove");
INSERT INTO Preferred_Editors (Name) VALUES ("axe");
INSERT INTO Preferred_Editors (Name) VALUES ("e3");
INSERT INTO Preferred_Editors (Name) VALUES ("kedit");
INSERT INTO Preferred_Editors (Name) VALUES ("vile");
INSERT INTO Preferred_Editors (Name) VALUES ("ae");
INSERT INTO Preferred_Editors (Name) VALUES ("* Other *");

INSERT INTO Registration_Type (Name, Cost) VALUES ("Concession", "99.00");
INSERT INTO Registration_Type (Name, Cost) VALUES ("Professional", "550.00");
INSERT INTO Registration_Type (Name, Cost) VALUES ("Hobbiest", "250.00");

INSERT INTO Extra_Charges (Name, Cost) VALUES ("Conference Dinner", "50.00");

INSERT INTO Time_Periods (Name, At) VALUES ("Start Registrations", "2002-04-01 00:00:00");
INSERT INTO Time_Periods (Name, At) VALUES ("Stop Registrations", "2003-01-10 00:00:00");

INSERT INTO Time_Periods (Name, At) VALUES ("Conference Start", "2003-01-22 08:00:00");
INSERT INTO Time_Periods (Name, At) VALUES ("Conference End", "2003-01-26 08:00:00");

INSERT INTO Variable (Name, Value) VALUES ("CommSecure_Modulus", "30228595767520873048540026229575593934896515252637120374368681474579105872020814891656341708651907867208299711325987355906532203980728291116828550425080685894217545141988325453206835015167239608707288467753001511407742419843758261549402595503699663267742887352924283703974451847");
INSERT INTO Variable (Name, Value) VALUES ("CommSecure_PublicKey", "40693");
#INSERT INTO Variable (Name, Value) VALUES ("CommSecure_URL", "commsecure/commsecure_server.cgi");
INSERT INTO Variable (Name, Value) VALUES ("CommSecure_URL", "https://clearance.commsecure.com.au/cgi-bin/GCDTemplate");
INSERT INTO Variable (Name, Value) VALUES ("CommSecure_MerchantNum", "CHANGEME");
INSERT INTO Variable (Name, Value) VALUES ("Num_Registered_And_Paid", "0");

INSERT INTO Discounts (Name, Access_Code, Discount_Percent, Count) VALUES ("Invited Speakers 2003", "Invited2003", 100, 8);


# Permissions
GRANT select on * to 'www-data'@localhost;
GRANT select,insert on Person to 'www-data'@localhost;
GRANT select,insert on Discounts_Used to 'www-data'@localhost;
GRANT select,insert on CommSecure_Request to 'www-data'@localhost;
GRANT select,insert on CommSecure_Payments to 'www-data'@localhost;
GRANT select,insert on CommSecure_Validate to 'www-data'@localhost;
GRANT select,insert on Receipt to 'www-data'@localhost;

__EOF__
