#!/usr/bin/perl -w
#
# This script is available under the Gnu General Public Licence (GPL)
#
# Written by James Bromberger (james@rcpt.to).
#
#
use strict;
use lib qw(../lib);
use Email;
use CGI;
use DBI;
use Person;
use CommSecure;

my $q = new CGI;
my $dbh = DBI->connect("dbi:mysql:database=LCA2003-Reg") or die "Can't connect";

my @people = Person->find(-dbh => $dbh);


sub get_person_details {
	my $person = shift;
	return unless defined $person;
	return $person->xml;
	my $text = sprintf "%s, %s, %s, %s, %s, %s\n",
		$person->name,
		$person->email_address,
		$person->custnum,
		$person->amount_total,
		$person->amount_paid,
		$person->amount_owing;
	return $text;
}

my $summary_text;
foreach my $person (@people) {
	my $text = get_person_details($person);
	$summary_text.=$text if defined $text;
}

exit unless defined $summary_text;
#print $summary_text if defined $summary_text;
Email->new(-to => 'backups@conf.linux.org.au', -subject => "[LCA2003] Hourly Registration Dump", -content => $summary_text) if defined $summary_text;

my $hour = (localtime)[2];
my $wday = (localtime)[6];
my $save_dir = "/var/tmp";
my $filename = "lca2003-people-backup.$wday.$hour";
die "Cannot save backup to $save_dir" unless -w $save_dir;
unlink "$save_dir/$filename.gz" if -r "$save_dir/$filename.gz";
open(F, ">", "$save_dir/$filename") or die "Cannot save to $filename";
print F $summary_text;
close F;
`gzip $save_dir/$filename`;
