#!/usr/bin/perl -w
#
# This script is available under the Gnu General Public Licence (GPL)
#
# Written by James Bromberger (james@rcpt.to).
#
#
use strict;
use lib qw(../lib/);
use Misc_Payment;
use Person;
use Form;
use DBI;
use CGI;

my $q = new CGI;
my $dbh = DBI->connect("dbi:mysql:database=LCA2003-Reg") or die "Can't connect";
my $f = Form->new(-query => $q, -dbh => $dbh);


sub form_get_details {
	my $query = shift;
	my $html = <<FOO;
<form>
<table border=0>
FOO
$html.= sprintf "<tr><td>Customer Number</td><td><input name=\"custnum\" value=\"%s\"></td></tr>\n", $query->param('custnum')||'';
$html.= sprintf "<tr><td>Amount (\$x.yy)</td><td><input name=\"amount\" value=\"%s\"></td></tr>\n", $query->param('amount')||'';
$html.= sprintf "<tr><td>Customer Comments</td><td><input name=\"customer_comments\" value=\"%s\"></td></tr>\n", $query->param('customer_comments')||'';
$html.= sprintf "<tr><td>Private Comments</td><td><input name=\"private_comments\"></td></tr>\n", $query->param('customer_comments')||'';
	$html.= <<FOO;
<tr><td colspan=2><input type="submit"></td></tr>
</table>
</form>

FOO

	return $html;
}

sub check_form {
	my $misc = shift;

	my ($person, undef) = Person->find(-dbh => $dbh, -custnum => $misc->custnum) if ((defined $misc) and (defined $misc->custnum));

}


sub save_it {
	my $misc = shift;

	return unless defined $misc;
	if (not defined $misc->custnum) {
		warn "No custnum";
		return;
	}
	my ($person, undef) = Person->find(-dbh => $dbh, -custnum => $misc->custnum);
	if (not defined $person) {
		warn "Couldnt find a matching person";
		return;
	}

	if (not(defined($person->name))|| not(defined($person->name))) {
		warn "No name or email address";
		return;
	}
	if ($misc->save) {
		my $receipt = Receipt->new(-dbh => $dbh, -person => $person, -misc => $misc, -generate => 1);
		die "No receipt" unless defined $receipt;
		my $signed = $receipt->text;
		die "No text in receipt for misc transaction" unless $signed;
		use Email;
		#my $email = Email->new(-to => 'james@rcpt.to', -bcc => 'treasurer@linux.conf.au', -subject => "[LCA2003] Payment Receipt: ". $person->name, -content => $signed);
		my $email = Email->new(-to => $person->email_address, -bcc => 'treasurer@linux.conf.au', -subject => "[LCA2003] Payment Receipt: " . $person->name, -content => $signed);
		return 1;
	} 
}


sub check_input {
	my $query = shift;
	#warn "Custnum is " . $query->param('custnum');
	#warn "Amount is " . $query->param('amount');
	my $m = Misc_Payment->new(-dbh => $dbh, -custnum => $query->param('custnum'), -amount => $query->param('amount')||'', -customer_comments => $query->param('customer_comments')||'', -private_comments => $query->param('private_comments'), -host => $query->remote_host, -operator => $query->remote_user());
	if (not($m->is_valid) and not defined($query->param('ok'))) {
		print $q->header;
		print $f->html_header;
		print form_get_details($query);
		print $f->html_footer;
	} elsif (($m->is_valid)  and not defined($query->param('ok'))) {
		$m->date(time());
		print $q->header;
		print $f->html_header;
		print $q->h2("Verify the payment");
		print $m->as_html;
		print "<form method=\"post\">\n";
		print $q->hidden("custnum", $query->param('custnum'));
		print "\n";
		print $q->hidden("amount", $query->param('amount'));
		print "\n";
		print $q->hidden("customer_comments", $query->param('customer_comments'));
		print "\n";
		print $q->hidden("private_comments", $query->param('private_comments'));
		print "\n";
		print $q->hidden("ok", "1");
		print "\n";
		print $q->hidden("date", $m->date);
		print "\n";
		print "<input type=\"submit\" value=\"Confirm -- issue receipt and save\">\n";
		print "</form>\n";
		print "<p>Press back to edit</p>\n";
		print $f->html_footer;
	} elsif ($m->is_valid && defined($query->param('ok')) && $query->param('ok') eq "1") {
		$m->date($query->param("date") || time());
		if (save_it($m)) {
			print $q->redirect('?ok=2');
		} else {
			print $q->header;
			print $f->html_header;
			print "<p>Failed to save.</p>";
			print $m->as_html;
			print $f->html_footer;
		}

	} else {
		print $q->header;
		print $f->html_header;
		print "<p>Saved. <a href=\"make_misc_payment.cgi\">Another...</a></p>";
	}
}

check_input($q);
