#!/usr/bin/perl -w
#
# This script is available under the Gnu General Public Licence (GPL)
#
# Written by James Bromberger (james@rcpt.to).
#
#
use strict;
use lib qw(../lib/);
use Misc_Payment;
use Form;
use DBI;
use CGI;

my $q = new CGI;
my $dbh = DBI->connect("dbi:mysql:database=LCA2003-Reg") or die "Can't connect";
my $f = Form->new(-query => $q, -dbh => $dbh);

my @list = Misc_Payment->find(-dbh => $dbh);


sub cs_amt_human {
	my $amt = shift;
	#my $new_val;
	#$new_val = "." . sprintf "%02d", substr($amt, -2);
	#$amt=$amt / 100;
	#while ($amt > 0) {
	#	$new_val = substr($amt, -3) . "," . $new_val;
	#	$amt = $amt/1000;
	#}
	return $amt;
}

sub time_human {
	my $time = shift;
	return unless $time;
	use integer;
	my $string;
	$string = sprintf "%02d", ($time % 60);
	$time/= 60;
	return $string unless $time;

	$string = sprintf("%02d", ($time %60)) . ":" . $string;
	$time/=60;
	return $string unless $time;

	$string = ($time % 24) . ":" . $string;
	$time/=24;
	return $string unless $time;

	$string = ($time % 7) . "d " . $string;
	$time/=7;
	return $string unless $time;
	$string = $time . "w " . $string;
	return $string;
}

print $q->header;
if (defined $q->param('refresh') && $q->param('refresh') =~ /^\d+$/) {
	printf $f->html_header(-header => "<meta http-equiv='refresh' content=%d>\n", $q->param('refresh'));
} else {
	print $f->html_header;
}

printf "<p>";
print  "<form method=get>Refreshing this page every <select name='refresh'>";
printf "<option %s>2", (defined ($q->param('refresh')) && $q->param('refresh') =~ /^\d+/ && $q->param('refresh') == 2)?"SELECTED":"";
printf "<option %s>5", (defined ($q->param('refresh')) && $q->param('refresh') =~ /^\d+/ && $q->param('refresh') == 5)?"SELECTED":"";
printf "<option %s>10", (defined ($q->param('refresh')) && $q->param('refresh') =~ /^\d+/ && $q->param('refresh') == 10)?"SELECTED":"";
printf "<option %s>30", (defined ($q->param('refresh')) && $q->param('refresh') =~ /^\d+/ && $q->param('refresh') == 30)?"SELECTED":"";
printf "<option %s>none", (not (defined $q->param('refresh')) || ($q->param('refresh') !~ /^\d+$/))?"SELECTED":"";
printf "</select><input type=submit value='seconds'>. <a href=\"commsecure_summary.cgi\">CommSecure Summary</a>.</form>\n\n";
print "<h2>Misc Payments</h2>\n";
print "<table>\n";

my $count=0;
printf "<tr><td>Number of misc payment</td><td>%d</td></tr>\n", $#list+1;

my $amount = 0;
map { $amount+= $_->amount} @list;
printf "<tr><td>Value of misc payments</td><td>%s</td></tr>\n", cs_amt_human($amount);


print "</table>\n\n\n";



if (@list) {
	print "<h2>Details</h2>\n\n";
	print "<table border=1>\n";
	print "<tr><th>Date</th><th>Host</th><th>Description</th><th>Note</th><th>Amount</th></tr>\n";
	foreach (sort {$a->date <=> $b->date} @list) {
		printf "<tr><td><small>%s</small></td><td>%s</td><td>%s</td><td>%s</td><td align=\"right\" style=\"color: green\">\$ %s</td></tr>\n",
			scalar localtime $_->date,
			$_->host,
			$_->customer_comments,
			$_->private_comments,
			cs_amt_human($_->amount);
	}
	print "</table>\n\n";
}


print $f->html_footer;
