#!/usr/bin/perl -w
#
# This script is available under the Gnu General Public Licence (GPL)
#
# Written by James Bromberger (james@rcpt.to).
#
#
use lib qw(lib);
use strict;
use CGI;
use DBI;
use Person;
use Form;
use Variable;
use CommSecure;

my $q = new CGI;
my $dbh = DBI->connect("dbi:mysql:database=LCA2003-Reg") or die "Can't connect";
my $f = Form->new(-query => $q, -dbh => $dbh);



sub html_head {
	print $q->header;
	print $f->html_header();
	#print $q->start_html;
	print $q->h2('Your transaction was declined');
}
sub html_tail {
	print $q->end_html;
	print $f->html_footer();
}

sub person_not_found {
	html_head();
	print $q->p("Looks like your transaction was declined by the bank! You can get your details from the <a href='my_details.cgi'>my details</a> page. Please try again when the issues with this card are resolved.");
	html_tail();
}

sub person_thank {
	my $person = shift;
	html_head();
	print $q->p("Sorry " . $person->name . ", but your transaction was declined by the bank. Please <a href=\"checkout.cgi?CustNum=" . $person->custnum . "\">try again</a> when your card is working, or try a different card.");
	html_tail();
}


if (defined $q->param('RefNum')) {
	my $transaction = CommSecure->new(-dbh => $dbh, -refnum => $q->param('RefNum'));
	if (not $transaction) {
		person_not_found();
		exit;
	} else {
		warn "Found the transaction " . $transaction->refnum;
	}
	my $person = Person->new(-custnum => $transaction->custnum, -dbh => $dbh);
	if (not $person) {
		person_not_found();
		exit;
	}
	person_thank($person);

} else {
	person_not_found();
}
