#!/usr/bin/perl -w
#
# This script is available under the Gnu General Public Licence (GPL)
#
# Written by James Bromberger (james@rcpt.to).
#
#
use lib qw(lib);
use strict;
use CGI;
use DBI;
use Person;
use Form;
use Variable;
use CommSecure;

my $q = new CGI;
my $dbh = DBI->connect("dbi:mysql:database=LCA2003-Reg") or die "Can't connect";
my $f = Form->new(-query => $q, -dbh => $dbh);



sub html_head {
	print $q->header;
	print $f->html_header();
	#print $q->start_html;
	print $q->h2('Thanks');
}
sub html_tail {
	print $q->end_html;
	print $f->html_footer();
}

sub person_not_found {
	html_head();
	print $q->p("Looks like you have finished your registration! You can get your details from the <a href='my_details.cgi'>my details</a> page. Thank you.");
	html_tail();
}

sub person_thank {
	my $person = shift;
	html_head();
	print $q->p("Thank you " . $person->name . " for your support. Don't forget to <a href=\"http://lists.linux.org.au/listinfo/lca-announce\">sign up to</a> lca-announce\@lists.linux.org.au mailing list so we can keep you up to date on any developments.");
	print $q->p("Your receipt will be emailed to the address you entered on  the registration form in the next few hours. If you don't receive this within 24 hours, or if your require a duplicate, please email lca-organisers\@conf.linux.org.au.");
	if (defined($person->accommodation_start) && defined($person->accommodation_end)) {
		warn "Has accommodaiton booked for " . $person->name;
		print $q->p(sprintf "Since you have requested accommodation at Currie Hall from %s to %s, please be sure to fill out the <strong><a href=\"Ch-booking.pdf\">Currie Hall booking form</a></strong> and get in contact with them to confirm this.", 
			$person->accommodation_start,
			$person->accommodation_end);
	#} else {
	#	warn "No accommodaiton for " . $person->name;
	}
	
	
	print $q->p("<a href=\"/\">Back to the home page</a>.");
	html_tail();
}


if (defined $q->param('RefNum')) {
	my $transaction = CommSecure->new(-dbh => $dbh, -refnum => $q->param('RefNum'));
	if (not $transaction) {
		person_not_found();
		exit;
	#} else {
		#warn "Found the transaction " . $transaction->refnum;
	}
	my $person = Person->new(-custnum => $transaction->custnum, -dbh => $dbh);
	if (not $person) {
		person_not_found();
		exit;
	}
	person_thank($person);

} else {
	person_not_found();
}
