package ExtraCharges;
#
## This script is available under the Gnu General Public Licence (GPL)
##
## Written by James Bromberger (james@rcpt.to).
##
#
sub new {
	my $proto = shift;
	my $class = ref($proto)||$proto;
	my $self = {};
	bless $self, $class;
	my %args = @_;
	$self->dbh($args{'-dbh'}) if defined $args{'-dbh'};
	if (defined $args{'-name'}) {
		return $self->load($args{'-name'});
		}
	return $self;
}

sub dbh {
	my $self = shift;
	if (@_) {
		$self->{'dbh'} = shift;
		}
	return $self->{'dbh'};
}

sub load {
	my $self = shift;
	my $name = shift;
	if (not $name) {
		warn "Name of variable not defined";
		return;
	}
	my $sql = "SELECT * from Extra_Charges where Name = ?";
	my $sth = $self->dbh->prepare($sql);
	my $res = $sth->execute($name);
	if ($res == 1) {
		my $ref = $sth->fetchrow_hashref;
		my $val = $ref->{'Cost'};
		$sth->finish;
		return $val;
	} elsif ($res > 1) {
		my @values;
		while (my $ref = $sth->fetchrow_hashref) {
			push @values, $ref->{'Cost'};
		}
		$sth->finish;
		return @values;
	} else {
		$sth->finish;
		return;
	}
}

1;
