#!/usr/bin/perl -w
#
## This script is available under the Gnu General Public Licence (GPL)
##
## Written by James Bromberger (james@rcpt.to).
##
#
use strict;
use CGI;

# We have several parts:
#
#  * Blank forms
#  * Filled in forms
#  * Processing data, redirecting
#  * Showing results
#
#  MAIN FORM, BLANK
#    -> Processing, redirect
#   |	-> COMPLETE
#   |	-> MAIN FORM, FILLED IN  ---\
#   |				    |
#   \-------------------------------/
#

# First, work out if we are processing data:
#
my $query = new CGI;
if (defined $query->param and not defined $query->param('display')) {
	# Process data, send the required redirect.

	# Do we have a valid Form Cookie? If we do, process, otherwise 
	# show an error message or redirect to a blank form.
	

	# Is there a form_cookie in the submitted data?
	if (not defined $query->param('form_cookie')) {
		warn "No cookie in form submission";
		print $query->redirect();
		return;
	}

	# Is it valid?
	my $c = new Form_Cookie(-find => $query->param('form_cookie'));
	if (not $c) {
		warn "Cookie not valid: " . $query->param('form_cookie');
		print $query->redirect();
		return;
	}

	# Is the rest of the form data valid
	my $p = new Person();
	if (not $p) {
		warn "Person details not valid";
		print $query->redirect();
		return;
	}
	
	# All detailsa re valid. Redirect to Thank You.
	print $query->redirect();
	return;

} elsif (defined $query->param('display')) {
	# Show a filled in form or a thank you.
	if ($query->param('display') eq "THANK") {
	} else {
	}
} else {
	# Show a blank form
}

1;
