#!/usr/bin/perl -w
#
# This script is available under the Gnu General Public Licence (GPL)
#
# Written by James Bromberger (james@rcpt.to).
#
use strict;
use lib qw(lib/);
use CGI;
use DBI;
use Person;
use Form;
use Email;

# 1 - ask for email address, and what they want sent
# 2 - find address, send email, redirect.
# 3 - inform user.

my $query = new CGI;
my $dbh = DBI->connect("dbi:mysql:database=LCA2003-Reg") or die "Can't connect";
my $f = Form->new(-query => $query, -dbh => $dbh);

# First, parse the input.
if (defined($query->param('email_address'))) {
	my @people = Person->find(-dbh => $dbh, -email => $query->param('email_address'));
	if ($#people > 0) {
		# Too many matches
		print $query->header;
		print $f->html_header();
		print "<h1>Too many matches</h1>\n";
		print "<p>It seems we have several matches for that address. Try again for your email address. If you did type your address correctly, please email lca-organisers\@conf.linux.org.au and let them know the address you typed.</p>\n";
		print "<form method=\"POST\">";
		print "<p>Email: <input name=\"email_address\"><input type=\"submit\">";
		print "</form>";
		print $f->html_footer;
	} elsif ($#people < 0) {
		# Not found
		print $query->header;
		print $f->html_header();
		print "<h1>Email address not found</h1>";
		print "<p>We dont know anyone by the address <tt>" . $query->escapeHTML($query->param('email_address')) . "</tt>. Perhaps you spelt it wrong, or have changed addresses? Please email the organisers for help.</p>";
		print $f->html_footer;
	} else {
		# Send the email, bounce on.
		#warn "Sending message to you";
		my $content = "Someone (probably you) recently requested that we send you the details\n that we (LCA2003) have on you.\n\n";
		$content.= $people[0]->person_text;
		#if (defined($query->param('receipts')) && $people[0]->receipts) {
		if ($people[0]->receipts) {
			foreach (@{$people[0]->receipts}) {
				$content.= sprintf "\n\nReceipt %s issued %s follows:\n\n",
					$_->id, scalar localtime $_->date;
				$content.= $_->text;
			}
				
		}
		#warn "Sending email";
		Email->new(-to => $people[0]->email_address, -subject => '[LCA2003] Registration Details: ' . $people[0]->name, -content => $content);
		print $query->redirect("?ok=1");
	}
} elsif (defined $query->param('ok')) {
	print $query->header();
	print $f->html_header();
	print "<H2>Message Sent</H2>";
	print "<p>Your details have been sent to you! <a href='./'>Continue...</a></p>";
	print $f->html_footer();
} else {
	# Show form
	#warn "Showing empty form";
	print $query->header();
	print $f->html_header();
	print "<form>";
	print "<p>Email: <input name=\"email_address\"><input type=\"submit\">";
	print "</form>";
	print $f->html_footer();
}
